config/routes.rb
Rails.application.routes.draw do
  get 'domain_names/index'
  get 'home/index'
  root 'home#index'
  # devise_for :users
  devise_for :users, :controllers => {:registrations => "devise/registrations"}
  resources :requests
  get '/connections/my_connections', to: 'connections#my_connections'
  get '/jobs/my_posted_jobs', to: 'jobs#my_posted_jobs'
  get '/jobs/my_applied_jobs', to: 'jobs#my_applied_jobs'
  get '/jobs/saved_jobs', to: 'jobs#saved_jobs'
  get '/jobs/states', to: 'jobs#states'
  get '/jobs/cities', to: 'jobs#cities'
  resources :connections
  resources :posts do
    resources :comments
    resources :likes
  end
  resources :comments do
    resources :likes
  end
  resources :user_groups, only: [:create, :destroy, :update]
  resources :user_jobs, only: [:create, :destroy, :update]
  resources :user_saved_jobs, only: [:create, :destroy, :update]
  resources :jobs
  resources :resumes
  resources :likes
  resources :groups
  resources :specialities, only: [:index]
  resources :domain_names, only: [:index]
  resources :poll_responses, only: [:create, :destroy]
  resources :registration_steps
  resources :events
  resources :businesses
  resources :courses
  resources :categories
  get '/get_users' => 'events#get_users'

  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
end

app/models/business.rb
class Business < ApplicationRecord
  has_one_attached :logo
  has_many :courses
  has_many :life_pages
  has_many :leaders
  has_many :users
  has_many :users, through: :businesses
  has_many :posts

  accepts_nested_attributes_for :life_pages

  def college
    #convert business_type to ENUM later
    business_type.include?('Medical College')
  end

  def medical_association #cant use just association. as ruby reserverd keyword.
    #convert business_type to ENUM later
    business_type.include?('Medical Association')
  end

  def hospital
    #convert business_type to ENUM later
    business_type.include?('Hospital')
  end

  def clinic
    #convert business_type to ENUM later
    business_type.include?('Clinic')
  end
end

app/models/category.rb
class Category < ApplicationRecord
    validates :name, presence: :true
    validates :name, uniqueness: :true


    has_many :courses
end

app/models/comment.rb
class Comment < ApplicationRecord
	belongs_to :commentable, polymorphic: true
	belongs_to :parent, class_name: 'Comment', optional: true
	has_many :replies, class_name: 'Comment', foreign_key: :parent_id, dependent: :destroy
	has_many :likes, as: :likeable
	# has_many :comments, as: :commentable

	scope :parent_comments, -> { where(parent_id: nil) }
end

app/models/country.rb
class Country < ApplicationRecord
end

app/models/course.rb
class Course < ApplicationRecord
	belongs_to :business
	belongs_to :category

	validates :title, :description, presence: :true
end

app/models/doctor.rb
class Doctor < ApplicationRecord
	acts_as :user

	# attr_accessor :mobile_no, :govt_id_proof, :country_id

	# validates :mobile_no, presence: :true
	
	has_one_attached :license
end

app/models/group.rb
class Group < ApplicationRecord
    validates :name, :description, presence: :true

    has_many :user_groups
    has_many :users, through: :user_groups
    belongs_to :creator, class_name: 'User', foreign_key: :user_id

    # scope :accepted, -> { joins(:user_groups).where('user_group.status=?', 1) }
end


# t.string "name"
# t.string "description"
# t.integer "user_id"
# t.boolean "visible"
# t.boolean "can_invite_connections"

app/models/hcp.rb
class Hcp < ApplicationRecord
	acts_as :user

	# attr_accessor :mobile_no, :govt_id_proof, :country_id

	# validates :mobile_no, presence: :true
	
	has_one_attached :license
end

app/models/job.rb
class Job < ApplicationRecord
    validates :title, :description, presence: :true
    belongs_to :creator, class_name: 'User', foreign_key: :user_id

    has_many :user_jobs
    has_many :users, through: :user_jobs

    def location
        [city_id, state_id, country_id].compact.join(', ').titleize
    end
end

app/models/leader.rb
class Leader < ApplicationRecord
	belongs_to :business
end

app/models/like.rb
class Like < ApplicationRecord
	belongs_to :likeable, polymorphic: true
end

app/models/non_hcp.rb
class NonHcp < ApplicationRecord
	acts_as :user

	# attr_accessor :mobile_no, :govt_id_proof, :country_id

	# validates :mobile_no, presence: :true
	
	has_one_attached :organization_id
end


#only single field is being stored in this table. organization attachment. other fields are inheriting from user table. cross check later

app/models/other.rb
class Other < ApplicationRecord
	acts_as :user

	# attr_accessor :mobile_no, :govt_id_proof, :country_id

	# validates :mobile_no, presence: :true
	
	has_one_attached :organization_id
end

app/models/poll.rb
class Poll < ApplicationRecord
    belongs_to :post
    has_many :poll_answers
    has_many :poll_responses
	accepts_nested_attributes_for :poll_answers, :reject_if => lambda { |a| a[:answer].blank? }, :allow_destroy => true
end

app/models/post.rb
class Post < ApplicationRecord
	attr_accessor :posting_as

	self.per_page = 10
	validates :title, presence: :true, if: -> { expert_opinion? }

	enum post_type: {
		normal_post: 0,
		question: 1,
		expert_opinion: 2,
		article: 3
	}

	has_rich_text :description

	has_many_attached :files
	has_one_attached :document #cover picture for article
	has_one_attached :clip
	belongs_to :user, optional: :true
	belongs_to :business, optional: :true

	has_many :comments, as: :commentable
	has_many :likes, as: :likeable
	has_many :polls
	accepts_nested_attributes_for :polls, :reject_if => lambda { |a| a[:question].blank? }, :allow_destroy => true

	def normal_post?
		post_type.include?('normal_post')
	end

	def question?
		post_type.include?('question')
	end

	def expert_opinion?
		post_type.include?('expert_opinion')
	end

	def article?
		post_type.include?('article')
	end

	def poll?
		post_type.include?('normal_post') && polls.present?
	end
end

app/models/request.rb
class Request < ApplicationRecord
	belongs_to :requestor, class_name: :User
  belongs_to :receiver, class_name: :User

  def self.request_connection(params)
	  Request.create(params)
	end
end

app/models/resume.rb
class Resume < ApplicationRecord
	has_one_attached :file

	validates :file, presence: true
	belongs_to :user
end

app/models/student.rb
class Student < ApplicationRecord
	acts_as :user

	# attr_accessor :mobile_no, :govt_id_proof, :country_id

	# validates :mobile_no, presence: :true

	has_one_attached :college_id
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  actable

  attr_accessor :speciality_id, :domain_id, :username, :current_step, :role, :about, :organization_id

  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable

  has_many :connection_requests_as_requestor,
    foreign_key: :requestor_id,
    class_name: :Request

  has_many :connection_requests_as_receiver, 
    foreign_key: :receiver_id,
    class_name: :Request

  has_many :a_users, foreign_key: :user_a_id, class_name: :Connection
  has_many :b_users, foreign_key: :user_b_id, class_name: :Connection
  has_many :owned_groups, class_name: 'Group'
  has_many :created_jobs, class_name: 'Job'
  has_many :posts
  has_many :poll_responses
  has_many :business_users
  has_many :businesses, through: :business_users

  has_many :user_groups
  has_many :groups, through: :user_groups

  has_many :user_jobs
  has_many :applied_jobs, through: :user_jobs, class_name: Job.to_s

  has_many :user_saved_jobs
  has_many :saved_jobs, through: :user_saved_jobs, class_name: Job.to_s

  has_one_attached :govt_id_proof
  has_many :resumes

  has_many :event_users
  has_many :events, through: :event_users

  validates :mobile_no, presence: :true, if: -> { current_step?('step_two') }

  before_validation :set_email, :if => Proc.new{ |u| username.present? && domain_id.present? }

  def current_step?(step_key)
    current_step == step_key
  end

  def incoming_pending_requests
    User.where(id: connection_requests_as_receiver.map{|request|request.requestor_id})
  end

  def outgoing_pending_requests
    User.where(id: connection_requests_as_receiver.map{|request|request.receiver_id})
  end

  def connected_users
    connections = Connection.where("user_a_id = ? OR user_b_id = ?", id, id)
    User.where(id: connections.map{|c| c.user_a_id != id ? c.user_a_id : c.user_b_id})
  end

  def name
    [first_name, last_name].compact.join(' ').titleize
  end

  def name_with_email
    [first_name, last_name, " (#{email})"].compact.join(' ').titleize
  end

  private

  def set_email
    domain = DomainName.find(domain_id)
    self.email = "#{username}@#{domain.name}"
  end
end

app/views/shared/_life_page_fields.html.erb
<div class="form-group col-md-12 mt-3">
	<%= f.label :view_name %><br />
	<%= f.text_field :page_name, class: "form-control" %>
</div>

<div class="form-group col-md-12 mt-3">
	<%= f.label :pixel_tracker_url %><br />
	<%= f.text_field :pixel_tracker_url, class: "form-control" %>
</div>

<div class="form-group col-md-12 mt-3">
	<%= f.label :main_image_or_video %><br />
	<%= f.file_field :image_or_video, class: "form-control" %>
</div>

<div>
	<%= f.fields_for :spotlights do |spotlight| %>
		<%= render 'spotlight_fields', :f => spotlight %>
	<% end %>
	
	<div class="links">
		<br>
		
		<%= link_to_add_association "Add Spotlight", f, :spotlights %> <!-- (*) -->
	</div>
</div>
	

app/views/shared/_manage_network_links.html.erb
<div class="col-md-3 manage-my-network">
    <div class='row'>
        <div class='col-md-12'>
            Manage my network
        </div>
    </div>
    <div class='row'>
        <div class='col-md-12'>
            <i class="fas fa-user-friends" aria-hidden="true"></i>
            <%= link_to 'Connections', connections_my_connections_path %> 
            <span class='float-right'> 2 </span>
        </div>
    </div>
    <div class='row'>
        <div class='col-md-12'>
            <i class="fa fa-users" aria-hidden="true"></i>
            <%= link_to 'Groups', groups_path %>
            <span class='float-right'> <%= @groups_count %> </span>
        </div>
    </div>
    <div class='row'>
        <div class='col-md-12'>
            <i class="fa fa-calendar" aria-hidden="true"></i>
            <%= link_to 'Events', events_path() %>
            <span class='float-right'> 12 </span>
        </div>
    </div>
    <div class='row'>
        <div class='col-md-12'>
            <i class="fa fa-file" aria-hidden="true"></i>
            <%= link_to 'Pages'%>
            <span class='float-right'> 12 </span>
        </div>
    </div>
    <div class='row'>
        <div class='col-md-12'>
            <i class="fa fa-file" aria-hidden="true"></i>
            <%= link_to 'Members'%>
            <span class='float-right'> 12 </span>
        </div>
    </div>
    <div class='row'>
        <div class='col-md-12'>
            <i class="fa fa-file" aria-hidden="true"></i>
            <%= link_to 'Students'%>
            <span class='float-right'> 12 </span>
        </div>
    </div>
		<div class='row'>
        <div class='col-md-12'>
            <i class="fa fa-file" aria-hidden="true"></i>
            <%= link_to 'Alumni'%>
            <span class='float-right'> 12 </span>
        </div>
    </div>
		<div class='row'>
        <div class='col-md-12'>
            <i class="fa fa-file" aria-hidden="true"></i>
            <%= link_to 'Employees'%>
            <span class='float-right'> 12 </span>
        </div>
    </div>
</div>

app/views/shared/_new_job_modal.html.erb
<!-- Modal -->
<div class="modal fade" id="newJobModal" tabindex="-1" aria-labelledby="newJobModalLabel" aria-hidden="true">
  <div class="modal-dialog modal-lg">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="newJobModalLabel">Create job</h5>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
      </div>
      <div class="modal-body" id='newJob'>
        <%= render 'jobs/form' %>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
        <button type="submit" form="new_job" class="btn btn-primary">Post Job</button>
      </div>
    </div>
  </div>
</div>

app/views/shared/_poll_answer_fields.html.erb
<div class="nested-fields mt-3">
	<div class="field">
		<%= f.label 'option' %>
		<%= link_to_remove_association "Remove", f, class: 'float-right' %>
		<%= f.text_field :answer, class: 'form-control' %>
	</div>
</div>

app/views/shared/_poll_btn_options.html.erb
<span class="votes-count-<%= poll.id%>"> <%= poll.votes_count  %> votes  </span> <span> . </span> <span> <%= poll.duration %> left </span> <span> . </span> 
<% if record %>
	<%= link_to 'undo', poll_response_path(record), remote: true, method: 'delete' %>
<% else %>
	<%= link_to 'Hide results', 'javascript:void(0)', class: 'hide-poll-results' %>
	<%= link_to 'View results', 'javascript:void(0)', class: 'view-poll-results' %>
<% end %>

app/views/shared/_poll_fields.html.erb
<div class="poll-fields">
	<%= f.label :your_question %>
	<%= f.text_area :question, class: 'form-control', placeholder: 'Eg. Which medicine is best for fever?' %>

	<%= f.fields_for :poll_answers do |poll_answer| %>
		<%= render 'shared/poll_answer_fields', :f => poll_answer %>
	<% end %>

	<div class="links mt-3 mb-3">
		<%= link_to_add_association "Add option", f, :poll_answers, partial: 'shared/poll_answer_fields', class: 'btn btn-sm btn-primary' %> <!-- (*) -->
	</div>
</div>

app/views/shared/_poll_results.html.erb
<% poll.poll_answers.each do |poll_answer| %>
    <div class='row'>
        <div class='col-md-1'>
            <%= poll_answer.answer %>
        </div>
        <div class='col-md-11'>
            <div class="progress mt-2">
                <div class="progress-bar" role="progressbar" style="width: <%= poll_answer.vote_percentage %>%;" aria-valuenow="<%= poll_answer.vote_percentage %>" aria-valuemin="0" aria-valuemax="100">
                    <%= poll_answer.vote_percentage %>%
                </div>
            </div>
        </div>
    </div>
<% end %>

app/views/shared/_respond_to_poll.html.erb
<% poll.poll_answers.each do |poll_answer| %>
	<div class='col-md-12 mt-2'>
		<%= link_to poll_answer.answer, poll_responses_path(poll_response: { user_id: current_user&.id, poll_answer_id: poll_answer.id, poll_id: poll.id	}), method: 'post', remote: true, class: 'poll-response', title: 'vote this option' %>
	</div>
<% end %>

app/views/shared/_topbar.html.erb
<!-- Navbar -->
<nav class="navbar navbar-expand-lg navbar-light bg-light fixed-top mb-5">
  <!-- Container wrapper -->
  <div class="container">
    <!-- Navbar brand -->
    <a class="navbar-brand" href="#"><i class="fab fa-linkedin fa-2x"></i></a>
    <!-- Search form -->
    <form class="input-group" style="width: 400px">
      <input type="search" class="form-control" placeholder="Type query" aria-label="Search" />
      <button class="btn btn-outline-primary" type="button" data-mdb-ripple-color="dark" style="padding: .45rem 1.5rem .35rem;">
        Search
      </button>
    </form>

     <% if user_signed_in? %>
        <%= link_to "Sign out", destroy_user_session_path, :method => :delete %> <%= current_user.email %>
      <% else %>
        <%= link_to "Sign In", new_user_session_path %>
      <% end %>


    <!-- Toggle button -->
    <button class="navbar-toggler" type="button" data-mdb-toggle="collapse"
      data-mdb-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false"
      aria-label="Toggle navigation">
      <i class="fas fa-bars"></i>
    </button>

    <!-- Collapsible wrapper -->
    <div class="collapse navbar-collapse" id="navbarSupportedContent">
      <!-- Left links -->
      <ul class="navbar-nav ms-auto mb-2 mb-lg-0">
        <li class="nav-item">
          <a class="nav-link d-flex flex-column text-center <%= @home_active %>" aria-current="page" href="<%= root_path %>"><i class="fas fa-home fa-lg"></i><span class="small mt-3">Home</span></a>
        </li>
        <li class="nav-item">
          <a class="nav-link d-flex flex-column text-center <%= @connections_active %>" aria-current="page" href="<%= connections_path %>"><i class="fas fa-user-friends fa-lg"></i><span class="small mt-3">My Network</span></a>
        </li>
        <li class="nav-item">
          <a class="nav-link d-flex flex-column text-center <%= @jobs_active %>" aria-current="page" href="<%= jobs_path %>"><i class="fas fa-briefcase fa-lg"></i><span class="small mt-3">Jobs</span></a>
        </li>
        <li class="nav-item">
          <a class="nav-link d-flex flex-column text-center" aria-current="page" href="#"><i class="fas fa-comment-dots fa-lg"></i><span class="small mt-3">Messaging</span></a>
        </li>
        <li class="nav-item">
          <a class="nav-link d-flex flex-column text-center" aria-current="page" href="#"><i class="fas fa-bell fa-lg"></i><span class="small mt-3">Notifications</span></a>
        </li>
        <li class="nav-item dropdown">
          <a
            class="nav-link dropdown-toggle d-flex align-items-center"
            href="#"
            id="navbarDropdownMenuLink"
            role="button"
            data-mdb-toggle="dropdown"
            aria-expanded="false"
          >
            <img
              src="https://mdbootstrap.com/img/Photos/Avatars/img%20(9).jpg"
              class="rounded-circle"
              height="30"
              alt=""
              loading="lazy"
            />
          </a>
          <ul class="dropdown-menu" aria-labelledby="navbarDropdownMenuLink">
            <li><a class="dropdown-item" href="#">My profile</a></li>
            <li><a class="dropdown-item" href="#">Settings</a></li>
            <li><a class="dropdown-item" href="#">Logout</a></li>
          </ul>
        </li>
      </ul>
      <!-- Left links -->
    </div>
    <!-- Collapsible wrapper -->
  </div>
  <!-- Container wrapper -->
</nav>
<!-- Navbar -->